"use strict";

exports.__esModule = true;
exports["default"] = RadioWrapper;

var _react = _interopRequireDefault(require("react"));

var _RadioGroup = _interopRequireDefault(require("../../../utils/radio/RadioGroup"));

var _TextInput = _interopRequireDefault(require("../../../utils/inputs/TextInput"));

var _jsxFileName = "/var/apps/ah-form-builder/src/components/app/fields-wrappers/Radio.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function RadioWrapper(props) {
  var _React$useState = _react["default"].useState(null),
      value = _React$useState[0],
      setValue = _React$useState[1];

  var _React$useState2 = _react["default"].useState(false),
      other = _React$useState2[0],
      setOther = _React$useState2[1];

  var _React$useState3 = _react["default"].useState(''),
      otherValue = _React$useState3[0],
      setOtherValue = _React$useState3[1];

  var handleChange = function handleChange(e) {
    var newValue = e.target.value;

    if (newValue === 'Specify Others') {
      setOther(true);
    } else {
      setOther(false);
      setOtherValue('');
    }

    setValue(newValue);
  };

  var handleOtherChange = function handleOtherChange(e) {
    setOtherValue(e.target.value);
  };

  var options = [];

  if (props.data.config.optionReferenceId) {
    options = _.cloneDeep(props.predefined[props.data.config.optionReferenceId].options);
  }

  if (props.data.config.enableOther) {
    options.push({
      id: -1,
      name: 'Specify Others'
    });
  }

  if (other) {
    return [/*#__PURE__*/_react["default"].createElement(_RadioGroup["default"], {
      label: props.data.name,
      required: props.data.config.isRequired,
      helperText: props.data.config.helpText,
      options: options,
      labelProp: "name",
      valueProp: "name",
      value: value,
      handleChange: handleChange,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 35,
        columnNumber: 7
      }
    }), /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
      handleChange: handleOtherChange,
      value: otherValue,
      placeholder: "Specify Others",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 45,
        columnNumber: 7
      }
    })];
  }

  return /*#__PURE__*/_react["default"].createElement(_RadioGroup["default"], {
    label: props.data.name,
    required: props.data.config.isRequired,
    helperText: props.data.config.helpText,
    options: options,
    labelProp: "name",
    valueProp: "name",
    value: value,
    handleChange: handleChange,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 54,
      columnNumber: 5
    }
  });
}

module.exports = exports.default;