"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _Drawer = _interopRequireDefault(require("./Drawer"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _ListItem = _interopRequireDefault(require("@material-ui/core/ListItem"));

var _icons = _interopRequireDefault(require("./icons"));

var _config = _interopRequireDefault(require("../../config"));

require("./styles.scss");

var _helpers = require("../../utils/helpers");

var _reactRedux = require("react-redux");

var _toolbarActions = require("../../actions/toolbarActions");

var _formActions = require("../../actions/formActions");

var _EditField = _interopRequireDefault(require("./EditField"));

var _jsxFileName = "/var/apps/ah-form-builder/src/components/toolbar/App.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var fields = [{
  label: 'Text Field',
  slug: 'text',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "text",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 15,
      columnNumber: 47
    }
  })
}, {
  label: 'Select / Dropdown',
  slug: 'select',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "select",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 16,
      columnNumber: 56
    }
  })
}, {
  label: 'Checkbox Group',
  slug: 'checkbox',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "checkbox",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 17,
      columnNumber: 55
    }
  })
}, {
  label: 'Radio Group',
  slug: 'radio',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "checkbox",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 18,
      columnNumber: 49
    }
  })
}, {
  label: 'Date Field',
  slug: 'date',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "date",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 19,
      columnNumber: 47
    }
  })
}, {
  label: 'Content',
  slug: 'content',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "content",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 20,
      columnNumber: 47
    }
  })
}, {
  label: 'File Upload',
  slug: 'file',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "file-upload",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 21,
      columnNumber: 48
    }
  })
}, {
  label: 'Quiz',
  slug: 'quiz',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "quiz",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 22,
      columnNumber: 41
    }
  })
}, {
  label: 'Survey',
  slug: 'survey',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "survey",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 23,
      columnNumber: 45
    }
  })
}, {
  label: 'List',
  slug: 'list',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "list",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 24,
      columnNumber: 41
    }
  })
}, {
  label: 'E-Signature',
  slug: 'signature',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "signature",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 25,
      columnNumber: 53
    }
  })
}, {
  label: 'Image',
  slug: 'image',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "image",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 26,
      columnNumber: 43
    }
  })
}, {
  label: 'Video',
  slug: 'video',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "video",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 27,
      columnNumber: 43
    }
  })
}, {
  label: 'Section',
  slug: 'section',
  'icon': /*#__PURE__*/_react["default"].createElement(_icons["default"], {
    name: "section",
    __self: void 0,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 28,
      columnNumber: 47
    }
  })
}];

var App = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(App, _React$Component);

  function App() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "addNewField", function (slug) {
      var data = (0, _helpers.generateSampleData)(slug, _this.props.order);

      _this.props.createField(data);
    });

    _defineProperty(_assertThisInitialized(_this), "onDragStart", function (e, slug) {
      e.dataTransfer.setData("droppedFieldSlug", slug);
    });

    _defineProperty(_assertThisInitialized(_this), "onDragEnd", function (e) {
      e.dataTransfer.setData("droppedFieldSlug", null);
    });

    _defineProperty(_assertThisInitialized(_this), "renderFieldItems", function () {
      var count = -1;
      return fields.map(function (field, index) {
        if (_config["default"].hiddenFields.indexOf(field.slug) === -1) {
          count++;
          return /*#__PURE__*/_react["default"].createElement("div", {
            className: count % 2 === 0 ? "col-md-6 pt-3 disable-highlight pr-1" : "col-md-6 pt-3 disable-highlight pl-1",
            key: 'field-' + field.slug,
            onDragStart: function onDragStart(e) {
              return _this.onDragStart(e, field.slug);
            },
            onDragOver: function onDragOver(e) {
              return e.preventDefault();
            },
            onDragEnd: function onDragEnd(e) {
              return _this.onDragEnd(e);
            },
            __self: _assertThisInitialized(_this),
            __source: {
              fileName: _jsxFileName,
              lineNumber: 50,
              columnNumber: 13
            }
          }, /*#__PURE__*/_react["default"].createElement(_ListItem["default"], {
            button: true,
            className: "p-0",
            __self: _assertThisInitialized(_this),
            __source: {
              fileName: _jsxFileName,
              lineNumber: 55,
              columnNumber: 15
            }
          }, /*#__PURE__*/_react["default"].createElement("div", {
            className: "field-type-container pt-3 cursor-pointer",
            onDoubleClick: function onDoubleClick(e) {
              return _this.addNewField(field.slug);
            },
            draggable: "true",
            onDragStart: function onDragStart(e) {
              return _this.onDragStart(e, field.slug);
            },
            onDragOver: function onDragOver(e) {
              return e.preventDefault();
            },
            __self: _assertThisInitialized(_this),
            __source: {
              fileName: _jsxFileName,
              lineNumber: 56,
              columnNumber: 15
            }
          }, field.icon, /*#__PURE__*/_react["default"].createElement(_Typography["default"], {
            variant: "subtitle1",
            gutterBottom: true,
            __self: _assertThisInitialized(_this),
            __source: {
              fileName: _jsxFileName,
              lineNumber: 62,
              columnNumber: 17
            }
          }, field.label))));
        }

        return '';
      });
    });

    return _this;
  }

  var _proto = App.prototype;

  _proto.render = function render() {
    if (this.props.editId || this.props.newFieldData) {
      return /*#__PURE__*/_react["default"].createElement("div", {
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 79,
          columnNumber: 9
        }
      }, /*#__PURE__*/_react["default"].createElement(_Drawer["default"], {
        title: "Question Types",
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 80,
          columnNumber: 11
        }
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "row m-0",
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 81,
          columnNumber: 13
        }
      }, /*#__PURE__*/_react["default"].createElement(_EditField["default"], {
        __self: this,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 82,
          columnNumber: 15
        }
      }))));
    }

    return /*#__PURE__*/_react["default"].createElement("div", {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 89,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react["default"].createElement(_Drawer["default"], {
      title: "Question Types",
      type: "fields",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 90,
        columnNumber: 9
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "row m-0",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 91,
        columnNumber: 11
      }
    }, this.renderFieldItems())));
  };

  return App;
}(_react["default"].Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    newFieldData: state.form.newFieldData,
    editId: state.toolbar.editId,
    data: state.form.data,
    order: state.form.order
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    enableFieldEdit: function enableFieldEdit(id, operation) {
      return dispatch((0, _toolbarActions.enableFieldEdit)(id, operation));
    },
    createField: function createField(data) {
      return dispatch((0, _formActions.createField)(data));
    },
    setOrder: function setOrder(data) {
      return dispatch((0, _formActions.setOrder)(data));
    }
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(App);

exports["default"] = _default;
module.exports = exports.default;