"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactRedux = require("react-redux");

var _TextField = _interopRequireDefault(require("./field-forms/TextField"));

var _Checkbox = _interopRequireDefault(require("./field-forms/Checkbox"));

var _Content = _interopRequireDefault(require("./field-forms/Content"));

var _Date = _interopRequireDefault(require("./field-forms/Date"));

var _File = _interopRequireDefault(require("./field-forms/File"));

var _Image = _interopRequireDefault(require("./field-forms/Image"));

var _List = _interopRequireDefault(require("./field-forms/List"));

var _Quiz = _interopRequireDefault(require("./field-forms/Quiz"));

var _Select = _interopRequireDefault(require("./field-forms/Select"));

var _Signature = _interopRequireDefault(require("./field-forms/Signature"));

var _Survey = _interopRequireDefault(require("./field-forms/Survey"));

var _Video = _interopRequireDefault(require("./field-forms/Video"));

var _Radio = _interopRequireDefault(require("./field-forms/Radio"));

var _Section = _interopRequireDefault(require("./field-forms/Section"));

var _jsxFileName = "/var/apps/ah-form-builder/src/components/toolbar/EditField.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function EditField(props) {
  var _this = this;

  var field = {};

  if (props.newFieldData) {
    field = props.newFieldData;
  } else {
    field = props.data[props.editId];
  }

  var renderFieldForms = function renderFieldForms() {
    switch (field.type) {
      case 'checkbox':
        return /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
          data: field,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 29,
            columnNumber: 11
          }
        });

      case 'radio':
        return /*#__PURE__*/_react["default"].createElement(_Radio["default"], {
          data: field,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 33,
            columnNumber: 11
          }
        });

      case 'content':
        return /*#__PURE__*/_react["default"].createElement(_Content["default"], {
          data: field,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 37,
            columnNumber: 13
          }
        });

      case 'date':
        return /*#__PURE__*/_react["default"].createElement(_Date["default"], {
          data: field,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 41,
            columnNumber: 13
          }
        });

      case 'file':
        return /*#__PURE__*/_react["default"].createElement(_File["default"], {
          data: field,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 45,
            columnNumber: 13
          }
        });

      case 'image':
        return /*#__PURE__*/_react["default"].createElement(_Image["default"], {
          data: field,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 49,
            columnNumber: 13
          }
        });

      case 'list':
        return /*#__PURE__*/_react["default"].createElement(_List["default"], {
          data: field,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 53,
            columnNumber: 13
          }
        });

      case 'quiz':
        return /*#__PURE__*/_react["default"].createElement(_Quiz["default"], {
          data: field,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 57,
            columnNumber: 13
          }
        });

      case 'select':
        return /*#__PURE__*/_react["default"].createElement(_Select["default"], {
          data: field,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 61,
            columnNumber: 13
          }
        });

      case 'signature':
        return /*#__PURE__*/_react["default"].createElement(_Signature["default"], {
          data: field,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 65,
            columnNumber: 13
          }
        });

      case 'survey':
        return /*#__PURE__*/_react["default"].createElement(_Survey["default"], {
          data: field,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 69,
            columnNumber: 13
          }
        });

      case 'text':
        return /*#__PURE__*/_react["default"].createElement(_TextField["default"], {
          data: field,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 73,
            columnNumber: 13
          }
        });

      case 'video':
        return /*#__PURE__*/_react["default"].createElement(_Video["default"], {
          data: field,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 77,
            columnNumber: 13
          }
        });

      case 'section':
        return /*#__PURE__*/_react["default"].createElement(_Section["default"], {
          data: field,
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 80,
            columnNumber: 16
          }
        });

      default:
        return /*#__PURE__*/_react["default"].createElement("div", {
          __self: _this,
          __source: {
            fileName: _jsxFileName,
            lineNumber: 83,
            columnNumber: 11
          }
        }, "Something magical happened");
    }
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "position-relative width-full",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 88,
      columnNumber: 5
    }
  }, renderFieldForms());
}

var mapStateToProps = function mapStateToProps(state) {
  return {
    newFieldData: state.form.newFieldData,
    editId: state.toolbar.editId,
    data: state.form.data
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {};
};

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(EditField);

exports["default"] = _default;
module.exports = exports.default;