"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _SimpleTabs = _interopRequireDefault(require("../../../utils/Tabs/SimpleTabs"));

var _TextInput = _interopRequireDefault(require("../../../utils/inputs/TextInput"));

var _Checkbox = _interopRequireDefault(require("../../../utils/checkboxs/Checkbox"));

var _ValidateField = _interopRequireDefault(require("../../../utils/validations/ValidateField"));

var _Button = _interopRequireDefault(require("@material-ui/core/Button"));

var _toolbarActions = require("../../../actions/toolbarActions");

var _formActions = require("../../../actions/formActions");

var _reactRedux = require("react-redux");

var _SearchableSelect = _interopRequireDefault(require("../../../utils/selects/SearchableSelect"));

var _MultiSelect = _interopRequireDefault(require("../../../utils/selects/MultiSelect"));

var _core = require("@material-ui/core");

var _richTextEditor = _interopRequireDefault(require("../../../utils/rich-text-editor"));

var _reactCustomScrollbars = require("react-custom-scrollbars");

var _conditionalLogic = _interopRequireDefault(require("../../../utils/conditional-logic"));

var _helpers = require("../../../utils/helpers");

var _jsxFileName = "/var/apps/ah-form-builder/src/components/toolbar/field-forms/File.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var supportedFileTypes = [{
  label: 'Images',
  value: 'images'
}, {
  label: 'PDF',
  value: 'pdf'
}, {
  label: 'Word Document',
  value: 'word'
}, {
  label: 'Video',
  value: 'video'
}, {
  label: 'Excel Sheet',
  value: 'excel'
}, {
  label: 'Presentation',
  value: 'presentation'
}];

var Select = /*#__PURE__*/function (_React$Component) {
  _inheritsLoose(Select, _React$Component);

  function Select(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "handleTabChange", function (e, newValue) {
      _this.setState({
        activeTab: newValue
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleDataChange", function (val, name) {
      var _this$setState;

      _this.setState((_this$setState = {}, _this$setState[name] = val, _this$setState.errors = {}, _this$setState));
    });

    _defineProperty(_assertThisInitialized(_this), "saveField", function () {
      var _this$state = _this.state,
          name = _this$state.name,
          machineName = _this$state.machineName,
          order = _this$state.order,
          conditionalLogic = _this$state.conditionalLogic,
          isRequired = _this$state.isRequired,
          placeholder = _this$state.placeholder,
          helpText = _this$state.helpText,
          subType = _this$state.subType,
          visibility = _this$state.visibility,
          uuid = _this$state.uuid,
          type = _this$state.type,
          isMultiple = _this$state.isMultiple,
          supportedFiles = _this$state.supportedFiles,
          parentId = _this$state.parentId;
      var newField = {
        name: name,
        machineName: machineName,
        order: order,
        uuid: uuid,
        type: type,
        parentId: parentId,
        config: {
          conditionalLogic: conditionalLogic,
          isRequired: isRequired,
          placeholder: placeholder,
          helpText: helpText,
          subType: subType,
          visibility: visibility,
          isMultiple: isMultiple,
          supportedFiles: supportedFiles
        }
      };
      (0, _ValidateField["default"])(newField).then(function () {
        _this.props.updateField(newField);

        _this.props.disableFieldEdit();
      })["catch"](function (errors) {
        var keys = Object.keys(errors);

        if (keys[0] === 'machineName' || keys[0] === 'conditionalLogic') {
          _this.handleTabChange({}, 'advance');
        } else {
          _this.handleTabChange({}, 'basic');
        }

        _this.setState({
          errors: errors
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "cancelEdit", function () {
      _this.props.deleteNewField();

      _this.props.disableFieldEdit();
    });

    _defineProperty(_assertThisInitialized(_this), "updateChoices", function (choices) {
      _this.setState({
        choices: choices
      });
    });

    _defineProperty(_assertThisInitialized(_this), "renderTabFields", function () {
      if (_this.state.activeTab === 'basic') {
        return /*#__PURE__*/_react["default"].createElement("div", {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 93,
            columnNumber: 9
          }
        }, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
          checked: _this.state.isRequired,
          handleChange: function handleChange(val) {
            return _this.handleDataChange(val, 'isRequired');
          },
          label: "Required",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 94,
            columnNumber: 11
          }
        }), /*#__PURE__*/_react["default"].createElement("div", {
          className: "mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 95,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
          value: _this.state.name,
          handleChange: function handleChange(e) {
            return _this.handleDataChange(e.target.value, 'name');
          },
          label: "Field Name",
          required: true,
          autoFocus: true,
          error: _this.state.errors.name,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 96,
            columnNumber: 13
          }
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 98,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
          value: _this.state.helpText,
          handleChange: function handleChange(e) {
            return _this.handleDataChange(e.target.value, 'helpText');
          },
          label: "Help Text",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 99,
            columnNumber: 13
          }
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 101,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
          value: _this.state.placeholder,
          handleChange: function handleChange(e) {
            return _this.handleDataChange(e.target.value, 'placeholder');
          },
          label: "Placeholder",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 102,
            columnNumber: 13
          }
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 104,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_MultiSelect["default"], {
          label: "Supported File Types",
          options: supportedFileTypes,
          value: _this.state.supportedFiles,
          handleChange: function handleChange(e) {
            return _this.handleDataChange(e.target.value, 'supportedFiles');
          },
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 105,
            columnNumber: 13
          }
        })), /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
          checked: _this.state.isMultiple,
          handleChange: function handleChange(val) {
            return _this.handleDataChange(val, 'isMultiple');
          },
          label: "Allow uploading multiple files",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 107,
            columnNumber: 11
          }
        }));
      } else {
        return /*#__PURE__*/_react["default"].createElement("div", {
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 112,
            columnNumber: 9
          }
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 113,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
          value: _this.state.machineName,
          handleChange: function handleChange(e) {
            return _this.handleDataChange(e.target.value, 'machineName');
          },
          label: "Machine Name/Field ID",
          required: true,
          autoFocus: true,
          error: _this.state.errors.machineName,
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 114,
            columnNumber: 13
          }
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "mb-4",
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 116,
            columnNumber: 11
          }
        }, /*#__PURE__*/_react["default"].createElement(_SearchableSelect["default"], {
          options: [{
            label: 'Visible',
            value: 'visible'
          }, {
            label: 'Hidden',
            value: 'hidden'
          }],
          label: "Visibility to Employee",
          value: _this.state.visibility ? 'visible' : 'hidden',
          handleChange: function handleChange(e) {
            return _this.handleDataChange(e.target.value === 'visible', 'visibility');
          },
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 117,
            columnNumber: 13
          }
        })), /*#__PURE__*/_react["default"].createElement(_conditionalLogic["default"], {
          conditionalLogic: _this.state.conditionalLogic,
          isConditionalEnabled: _this.state.isConditionalEnabled,
          handleChange: _this.handleDataChange,
          errors: _this.state.errors.conditionalLogic ? _this.state.errors.conditionalLogic : [],
          __self: _assertThisInitialized(_this),
          __source: {
            fileName: _jsxFileName,
            lineNumber: 119,
            columnNumber: 11
          }
        }));
      }
    });

    var _choices = [{
      name: 'Choice 1',
      value: 1
    }, {
      name: 'Choice 2',
      value: 2
    }, {
      name: 'Choice 3',
      value: 3
    }];
    _this.state = _extends({
      choices: _choices,
      activeTab: 'basic',
      errors: {},
      uuid: props.data.uuid,
      name: props.data.name,
      type: props.data.type,
      order: props.data.order,
      parentId: props.data.parentId,
      machineName: props.data.machineName,
      isConditionalEnabled: !!props.data.config.conditionalLogic.length
    }, props.data.config);
    return _this;
  }

  var _proto = Select.prototype;

  _proto.render = function render() {
    return /*#__PURE__*/_react["default"].createElement("div", {
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 127,
        columnNumber: 7
      }
    }, /*#__PURE__*/_react["default"].createElement(_SimpleTabs["default"], {
      value: this.state.activeTab,
      handleChange: this.handleTabChange,
      options: [{
        label: 'Basic Settings',
        value: 'basic'
      }, {
        label: 'Advance Settings',
        value: 'advance'
      }],
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 128,
        columnNumber: 9
      }
    }), /*#__PURE__*/_react["default"].createElement(_reactCustomScrollbars.Scrollbars, {
      style: {
        height: (0, _helpers.getHeight)(true, true)
      },
      autoHide: true,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 129,
        columnNumber: 9
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "p-3 my-3",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 130,
        columnNumber: 11
      }
    }, this.renderTabFields(), /*#__PURE__*/_react["default"].createElement("div", {
      className: "width-full text-right",
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 132,
        columnNumber: 13
      }
    }, /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      variant: "outlined",
      color: "primary",
      className: "mr-2",
      onClick: this.cancelEdit,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 133,
        columnNumber: 15
      }
    }, "Cancel"), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
      variant: "contained",
      color: "primary",
      disableElevation: true,
      onClick: this.saveField,
      __self: this,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 136,
        columnNumber: 15
      }
    }, "Save")))));
  };

  return Select;
}(_react["default"].Component);

var mapStateToProps = function mapStateToProps(state) {
  return {
    operation: state.toolbar.operation,
    predefined: state.form.predefined
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    disableFieldEdit: function disableFieldEdit() {
      return dispatch((0, _toolbarActions.disableFieldEdit)());
    },
    deleteNewField: function deleteNewField() {
      return dispatch((0, _formActions.deleteNewField)());
    },
    createField: function createField(data) {
      return dispatch((0, _formActions.createField)(data));
    },
    updateField: function updateField(data) {
      return dispatch((0, _formActions.updateField)(data));
    },
    deleteField: function deleteField(id) {
      return dispatch((0, _formActions.deleteField)(id));
    }
  };
};

var _default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(Select);

exports["default"] = _default;
module.exports = exports.default;