"use strict";

exports.__esModule = true;
exports["default"] = NewOption;

var _react = _interopRequireDefault(require("react"));

var _TextInput = _interopRequireDefault(require("../inputs/TextInput"));

var _IconButton = _interopRequireDefault(require("@material-ui/core/IconButton"));

var _Done = _interopRequireDefault(require("@material-ui/icons/Done"));

var _helpers = require("../helpers");

var _jsxFileName = "/var/apps/ah-form-builder/src/utils/predefined-values/NewOption.js";

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function NewOption(props) {
  var _React$useState = _react["default"].useState(''),
      name = _React$useState[0],
      setName = _React$useState[1];

  var _React$useState2 = _react["default"].useState(''),
      value = _React$useState2[0],
      setValue = _React$useState2[1];

  var _React$useState3 = _react["default"].useState(''),
      updated = _React$useState3[0],
      setUpdated = _React$useState3[1];

  var _React$useState4 = _react["default"].useState(''),
      error = _React$useState4[0],
      setError = _React$useState4[1];

  var handleNameChange = function handleNameChange(e) {
    setError('');
    setName(e.target.value);
  };

  var handleValueChange = function handleValueChange(e) {
    setError('');
    setValue(e.target.value);
  };

  var saveNewOption = function saveNewOption(e) {
    e.preventDefault();
    var values = [];
    var properValue = value;

    if (!value || value === '') {
      properValue = (0, _helpers.stringToSlug)(name);
    }

    props.options.map(function (option) {
      values.push(option.name);
    });

    if (values.includes(name)) {
      setError('Category with same name already exists.');
    } else {
      props.saveNewCategoryOption(name, properValue);
      setName('');
      setValue('');
    }
  };

  return /*#__PURE__*/_react["default"].createElement("form", {
    onSubmit: saveNewOption,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 43,
      columnNumber: 5
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "pl-3 row",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 44,
      columnNumber: 7
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "col-md-6",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 45,
      columnNumber: 9
    }
  }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
    placeholder: "Name",
    value: name,
    handleChange: handleNameChange,
    autoFocus: true,
    error: error,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 46,
      columnNumber: 11
    }
  })), /*#__PURE__*/_react["default"].createElement("div", {
    className: "col-md-6",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 54,
      columnNumber: 9
    }
  }, /*#__PURE__*/_react["default"].createElement(_TextInput["default"], {
    placeholder: "Value",
    value: value,
    handleChange: handleValueChange,
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 55,
      columnNumber: 11
    }
  }))), /*#__PURE__*/_react["default"].createElement("button", {
    className: "hidden",
    type: "submit",
    __self: this,
    __source: {
      fileName: _jsxFileName,
      lineNumber: 62,
      columnNumber: 7
    }
  }, "Submit"));
}

module.exports = exports.default;